/*
 *	   c l o s e _ c
 *
 *	This file is part of the LIBRLL library.
 *
 * (c) Copyright 1999 David J. Walker
 *	   Email:  dave.walker@icl.com
 *
 *	   Permission to copy and/or distribute is granted under the
 *	   following conditions:
 *
 *	   1). This notice must remain intact.
 *	   2). The author is not responsible for the consequences of use
 *		   this software, no matter how awful, even if they arise
 *		   from defects in it.
 *	   3). Altered versions must not be represented as being the
 *		   original software.
 */

#include "librll.h"

/*
 *	Close file and release resources
 */
int 	RLL_Close (RLL_FILE ** prp)
{
	if (NULL == prp || NULL == *prp)
	{
		return RLL_ERROR_NONE;
	}

	if ((*prp)->fd > 0)
	{
		(void) close ((*prp)->fd);
	}
	return RLL_CloseFile(prp);
}

/*
 *	Release resources
 */
int 	RLL_CloseFile (RLL_FILE ** prp)
{
	if (NULL == prp || NULL == *prp)
	{
		return RLL_ERROR_NONE;
	}
	free ((*prp)->rll_header);
	free (*prp);
	*prp = NULL;

	return RLL_ERROR_NONE;
}
